package uk.org.wuglug.gryle;

import javax.swing.LookAndFeel;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import com.sun.java.swing.plaf.gtk.GTKLookAndFeel;

import uk.org.wuglug.gryle.ui.v.FrontEnd;

/**
 * Entry point for program
 * @author Richard Warburton
 * Gryle is a Feral Banshee
 */
public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		setupLAF();
		
		FrontEnd.getInstance();
	}

	/**
	 * Tries to use a system LAF, otherwise uses crossplatform
	 */
	private static void setupLAF() {
		String lookAndFeel = null;
		try {
			lookAndFeel = UIManager.getSystemLookAndFeelClassName();
			//System.out.println(lookAndFeel);
			UIManager.setLookAndFeel(lookAndFeel);
		} catch (Exception e) {
			lookAndFeel = UIManager.getCrossPlatformLookAndFeelClassName();
			try {
				UIManager.setLookAndFeel(lookAndFeel);
			} catch (Exception e1) {
				e1.printStackTrace();
				System.exit(-1);
			}
		}
		//  GTKLookAndFeel laf = (GTKLookAndFeel) UIManager.getLookAndFeel();
	}

}
