/**
 * 
 */
package uk.org.wuglug.gryle.ui.m;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import uk.org.wuglug.gryle.ui.v.FrontEnd;
import uk.org.wuglug.gryle.ui.v.MainMenu;
import uk.org.wuglug.gryle.util.SongDirectory;

/**
 * @author mulletron
 *
 */
public class MenuController implements ActionListener {

	private static MenuController ctrl = new MenuController();
	
	/**
	 * @return the ctrl
	 */
	public static MenuController getCtrl() {
		return ctrl;
	}

	/**
	 * @see java.awt.event.ActionListener#actionPerformed(java.awt.event.ActionEvent)
	 */
	public void actionPerformed(ActionEvent e) {
		String actionCommand = e.getActionCommand();
		if(actionCommand.equals(MainMenu._ABOUT)) {
			System.out.println("TODO");
			
		} else if(actionCommand.equals(MainMenu._DELETE)) {
			if(SongTableModel.getInst().delete()) {
				System.out.println("DELETED");
			} else {
				System.out.println("DELETE FAILED");
			}
			
		} else if(actionCommand.equals(MainMenu._IMPORT)) {
			importMusic();
			
		} else if(actionCommand.equals(MainMenu._QUIT)) {
			System.exit(1);
			
		} else if(actionCommand.equals(MainMenu._REMOVE)) {
			SongTableModel.getInst().remove();
			
		} else if(actionCommand.equals(MainMenu._PREFERENCES)) {
			System.out.println("TODO");
		}
	}

	private void importMusic() {
		String filename = System.getProperty("user.home");
		filename = "/media/sdc1/Availible/";
		JFileChooser fc = new JFileChooser(new File(filename));
		fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
	    
	    // Show open dialog; this method does not return until the dialog is closed
	    fc.showOpenDialog(FrontEnd.getInstance());
	    File selectedFile = fc.getSelectedFile();
	    if(!selectedFile.isDirectory()) {
	    	JOptionPane.showMessageDialog(null, "File cannot be a directory");
	    } else {
	    	new SongDirectory(selectedFile);
	    }
	}

}
