/**
 * 
 */
package uk.org.wuglug.gryle.ui.v;

import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.ListSelectionModel;
import javax.swing.border.EtchedBorder;
import javax.swing.table.DefaultTableColumnModel;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;

import uk.org.wuglug.gryle.ui.m.SongModel;
import uk.org.wuglug.gryle.ui.m.SongTableModel;

import com.sun.java.swing.plaf.motif.MotifBorders.BevelBorder;

/**
 * @author Richard Warburton
 * The view for the Bottom half of the front end gui.
 */
public class BottomPanel extends Box implements KeyListener {

	protected JTextField searchInput;
	
	protected SongTableModel songTableModel;
	protected TableColumnModel columnModel;
	protected JTable songTable;
	protected JScrollPane scrollPane;

	public BottomPanel() {
		super(BoxLayout.Y_AXIS);
		init();
	}

	private void init() {
		
		setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		setOpaque(true);
		
		this.songTableModel = SongTableModel.getInst();
		this.columnModel = new DefaultTableColumnModel();
		//  TODO: refactor this shit out of the view, or write a proper model
		int n = SongModel.Columns.length;
		for(int i = 0;i<n;i++) {
			String column = SongModel.Columns[i];
			TableColumn tc = new TableColumn();
			tc.setModelIndex(i);
			//tc.setCellRenderer(new SongCellRenderer());
			tc.setHeaderValue(column);
			this.columnModel.addColumn(tc);
		}
		this.songTable = new JTable(songTableModel,this.columnModel);
		this.songTable.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		
		this.songTableModel.setView(this.songTable);
		this.scrollPane = new JScrollPane(this.songTable);
		
		this.searchInput = new JTextField(10);
		this.searchInput.addKeyListener(this);
		
		Box top = Box.createHorizontalBox();
		top.add(Box.createHorizontalGlue());
		top.add(Box.createHorizontalStrut((int) (getWidth()*0.75)));
		top.add(this.searchInput);
		
		add(top);
		add(Box.createVerticalStrut(5));
		add(Box.createVerticalGlue());
		add(this.scrollPane);
		
	}

	public void keyPressed(KeyEvent e) {}
	public void keyReleased(KeyEvent e) {}

	public void keyTyped(KeyEvent e) {
		String text = null;
		if((int)e.getKeyChar() == 8) {
			text = this.searchInput.getText();
		} else {
			text = this.searchInput.getText()+e.getKeyChar();
		}
		this.songTableModel.filter(text);
	}
}
