/**
 * 
 */
package uk.org.wuglug.gryle.ui.v;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;

import uk.org.wuglug.gryle.ui.m.MenuController;

/**
 * @author Richard Warburton
 * The program's menu system.
 * The controller is located in m.MenuController
 */
public class MainMenu extends JMenuBar {
	//public static final String _S_ALL = "Select All";
	//public static final String _S_NONE = "Select None";

	public static final String _IMPORT = "Import";
	public static final String _QUIT = "Quit";
	public static final String _REMOVE = "Remove Song";
	public static final String _DELETE = "Delete Song";
	public static final String _PREFERENCES = "Preferences";
	public static final String _ABOUT = "About";
	
	
	class MenuItem extends JMenuItem {
		public MenuItem(String name) {
			super(name);
			setActionCommand(name);
			addActionListener(MenuController.getCtrl());
		}
	}
	
	class Music extends JMenu {
		public Music() {
			super("Music");
			add(new MenuItem(_IMPORT));
			addSeparator();
			add(new MenuItem(_QUIT));
		}
	}
	
	class Edit extends JMenu {
		public Edit() {
			super("Edit");
			add(new MenuItem(_REMOVE));
			add(new MenuItem(_DELETE));
			addSeparator();
			add(new MenuItem(_PREFERENCES));
			//add(new MenuItem(_S_ALL));
			//add(new MenuItem(_S_NONE));
		}
	}
	
	class Help extends JMenu {
		public Help() {
			super("Help");
			add(new MenuItem(_ABOUT));
		}
	}
	
	public MainMenu() {
		add(new Music());
		add(new Edit());
		add(new Help());
	}
}
