/**
 * 
 */
package uk.org.wuglug.gryle.util;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

/**
 * @author rlmw
 *
 */
public abstract class AbstractMusicPlayer implements MusicPlayer {
	
	protected InputStream in;
	protected long delay;
	protected List<MusicListener> listeners;
	
	public AbstractMusicPlayer() {
		this.listeners = new ArrayList<MusicListener>();
	}
	
	public long getDelay() {
		return delay;
	}
	public void setDelay(long delay) {
		this.delay = delay;
	}
	
	public InputStream getInput() {
		return in;
	}
	public void setInput(InputStream in) {
		this.in = in;
	}
	
	public void addListener(MusicListener listener) {
		this.listeners.add(listener);
	}
	
	public void removeListener(MusicListener listener) {
		this.listeners.remove(listener);
	}

}
