/**
 * 
 */
package uk.org.wuglug.gryle.util;

import java.io.File;
import java.io.FilenameFilter;
import java.util.ArrayList;
import java.util.List;

import javax.swing.filechooser.FileFilter;

import uk.org.wuglug.gryle.ui.m.SongColumnModel;
import uk.org.wuglug.gryle.ui.m.SongModel;
import uk.org.wuglug.gryle.ui.m.SongTableModel;

/**
 * @author mulletron
 * Class for keeping track of songs in a given directory
 * Every song directory is a File instance that is a readable directory
 */
public class SongDirectory {

	/**
	 * @author mulletron
	 * Filters file to ensure that they are files
	 */
	public static class SongFileFilter implements FilenameFilter {

		private static String[] extension = {
			".mp3",
			".wav"
		};

		public boolean accept(File path, String name) {
			for(String ext:extension) {
				if(name.endsWith(ext)) {
					return true;
				}
			}
			return false;
		}
		
	}
	
	private static FilenameFilter filter = new SongFileFilter();
	
	private List<File> contents;
	private File dir;
	
	public SongDirectory(File dir) {
		this.dir = dir;
		if(!dir.isDirectory() || !dir.canRead()) {
			throw new ExceptionInInitializerError();
		}
		this.contents = new ArrayList<File>();
		update();
	}

	/**
	 * Updates the files
	 * Currently naive
	 */
	public void update() {
		listAll(this.dir);
		SongTableModel songs = SongTableModel.getInst();
		
		songs.addAll(contents);
		System.out.println(songs.getRowCount());
	}
	
	/**
	 * Enumerates all files within this directory and subdirectories
	 * @param file
	 */
	private void listAll(File file) {
		File[] files = file.listFiles(filter);
		//File[] files = file.listFiles();
		for(File f:files) {
			if(f.isDirectory()) {
				listAll(f);
			} else {
				this.contents.add(f);
			}
		}
	}

}
